package com.gemho.dao;

import java.sql.Timestamp;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import com.gemho.bean.TabMessage;
import com.gemho.daoIf.MessageDao;
import com.gemho.util.HibernateUtil;

public class MessageImpl implements MessageDao {
	@SuppressWarnings("unchecked")
	public List<Object> SelectAllMessage(){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List <Object> list = null;
		try
		{
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
				query = session.createQuery(" from  TabMessage object2 order by id   ");
			list = query.list();
			/*for(int i = 0; i<list.size()-1; i++){
				TabMessage mes = (TabMessage)list.get(i);
				mes.setXianshi("ѹ");
			}
			TabMessage nas = (TabMessage)list.get(list.size()-1);
			nas.setXianshi("ʹ");*/
			tx.commit();
		}
		catch(Exception ex)
		{
			if(null != tx)
			{
				tx.rollback();
			}
		}
		finally
		{
			HibernateUtil.close(session);
		}
		return list;
	}
	public int updateMessage(int id,int shifoufasong,String haoma,String shezhiren,String neirong){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		Timestamp timestamp = new Timestamp(System.currentTimeMillis());
		try{
			TabMessage mes = selMessage(id);
			mes.setShifoufasong(shifoufasong);
			mes.setHaoma(haoma);
			mes.setShedingtime(timestamp);
			mes.setShezhiren(shezhiren);
			mes.setNeirong(neirong);
			session.update(mes);
			tx.commit();
			return 1;
		}catch(Exception ex ){
			ex.printStackTrace();
			if(null != tx)
			{
				tx.rollback();
			}
			return 0;
		}
		finally
		{
			HibernateUtil.close(session);
		}
	}
	public int AddMessage(int shifoufasong,String haoma,String shezhiren,String neirong){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		//Calendar calendat = Calendar.getInstance();
		//SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		//String dateStr = sdf.format(calendat.getTime());
		Timestamp timestamp = new Timestamp(System.currentTimeMillis());
		int i = 0 ;
		
		try {
			//String stradd = "insert into tab_message (id,shifoufasong,  haoma,shedingtime,shezhiren,neirong) values ('"+id+"','"+haoma+"','"+formatter.format(new Date())+
            //"','"+shezhiren+"','"+neirong+"')";
			/*if(haoma.contains("") == true){
				String[] str1 = haoma.split("");
				
				haoma = "";
				for(int j = 0 ; j<str1.length ; j++){
					if(j>0){
						haoma += ",";
					}
					haoma += str1[j];
					
				}
			}
			String[] str = haoma.split(",");
			int count = 0;
			for(int m = 0 ;m< str.length ; m++){
				boolean ifhege = regex(str[m]);
				if(ifhege == false){
					count ++;
				}
			}
			if(count == 0 ){*/
			TabMessage mes = new TabMessage();
			mes.setShifoufasong(shifoufasong);
			mes.setHaoma(haoma);
			mes.setShedingtime(timestamp);
			mes.setShezhiren(shezhiren);
			mes.setNeirong(neirong);
			i = (Integer)session.save(mes);
			tx.commit();
			return i;
			/*}else{
				return 0;
			}*/
			
			
		} catch(Exception ex)
		{
			ex.printStackTrace();
			if(null != tx)
			{
				tx.rollback();
			}
			return 0;
		}
		finally
		{
			HibernateUtil.close(session);
		}
		
	}
	public boolean regex(String haoma){
		String format = "^[1][3-8]\\d{9}$";
		Pattern p = Pattern.compile(format);
		Matcher m = p.matcher(haoma);
		boolean flat = m.matches();
		return flat;
	}
	public boolean delMessage(int id){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try{
			//int i = Integer.parseInt(id);
			Query query ;
			query = session.createQuery("from TabMessage ta where ta.id=?");
			query.setInteger(0, id);
			TabMessage ms = (TabMessage)query.uniqueResult();
			session.delete(ms);
			tx.commit();
			return true;
		}catch(Exception ex){
			if(null != tx)
			{
				tx.rollback();
			}
			return false;
		}finally{
			HibernateUtil.close(session);
		}
	}
	public TabMessage selMessage(int id){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			Query query;
			query = session.createQuery("from TabMessage ta where ta.id=?");
			query.setInteger(0, id);
			TabMessage ms = (TabMessage)query.uniqueResult();
			tx.commit();
			return ms;
		} catch(Exception ex){
			if(null != tx)
			{
				tx.rollback();
			}
			return null;
		}finally{
			HibernateUtil.close(session);
		}
	}
}
