package com.gemho.dao;

import com.gemho.daoIf.StationConfigDao;

import com.gemho.util.HibernateUtil;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;
import org.springframework.orm.hibernate3.HibernateTemplate;

import java.util.*;

public class StationConfigImpl implements StationConfigDao {
	private HibernateTemplate ht;
	public HibernateTemplate getHt() {
		return ht;
	}
	public void setHt(HibernateTemplate ht) {
		this.ht = ht;
	}

	@Override
	public List findStationConfigInfo() {
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<Object> list = null;
		try {
			String sql = "select zduan from tab_station where id < 10 group by zduan order by zduan asc";
			Query query = session.createSQLQuery(sql).setResultTransformer(
					Transformers.ALIAS_TO_ENTITY_MAP);
			list = (List<Object>) query.list();
		}catch(Exception e){
			e.printStackTrace();
		}
		return list;
	}

}

