package com.gemho.dao;

import java.io.DataOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;
import org.springframework.orm.hibernate3.HibernateTemplate;
import com.gemho.bean.TabAlarmlog;
import com.gemho.bean.TabNeibuchenjiang;
import com.gemho.bean.TabSensor;
import com.gemho.bean.value;
import com.gemho.bean.value2;
import com.gemho.daoIf.neibuchenjiangDao;
import com.gemho.util.HibernateUtil;

public class neibuchenjiangImpl implements neibuchenjiangDao {
	private HibernateTemplate ht;
	public HibernateTemplate getHt() {
		return ht;
	}
	public void setHt(HibernateTemplate ht) {
		this.ht = ht;
	}
	@SuppressWarnings("unchecked")
	public List getWeiZhi(String mark,String state) {
		Session session = HibernateUtil.openSession();
		List list= null;
		List list1= null;
		String sql = "FROM TabSensor WHERE mark = '"+mark+"' and state ='"+state+"'order by name";
		try {
			list = session.createQuery(sql).list();
			for (int i = 0; i < list.size(); i++) {
				TabSensor sensor = ((TabSensor)list.get(i));
				String x = null,y = null; 
				if(sensor!=null){
					String address2 = sensor.getAddress2();
					if(address2!= null && address2.contains("|")){
						//x|y ȡ֮ͼλ
						x = address2.split("\\|")[0];
						y = address2.split("\\|")[1];
						//ısensor ֵ 
						sensor.setAddress2(x);//λx
						sensor.setNotalarmvalue(y);//ʼλ
					}
				}
				//ѯһ¼ жλ
				list1 = session.createQuery("FROM TabNeibuchenjiang where sensorname = '" + sensor.getName()+ "' and jctime = (SELECT max(jctime) FROM TabNeibuchenjiang where ifview = 1 and ifstart =0 and sensorname = '" + sensor.getName()+ "' )").list();
				if(list1.size()>0){
					TabNeibuchenjiang nbcj = (TabNeibuchenjiang)list1.get(0);
					double value = nbcj.getValue2();
					//λ x,y(h)ʼ-仯value
					double h = Double.parseDouble(y)- value;
					//ısensor 1ֵ 
					//sensor.setBzuobiao(x);//λx
					sensor.setKind(h+"");//λ
				}else{
					//sensor.setBzuobiao(x);//λx
					sensor.setKind(y);//λ
				}
				
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return list;
	}
	
	@SuppressWarnings("unchecked")
	public List<Object> Search_Page_new_ls(String mark,String state) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		String sql = "";
		List listAll = new ArrayList();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			String a = "SELECT zkbh FROM TabSensor WHERE mark = '"+mark+"' and state ='"+state+"' group by zkbh order by zkbh";
			List zkbh = session.createQuery(a).list();
			for (int i = 0; i < zkbh.size(); i++) {
				String zk = zkbh.get(i).toString();
				String b = "FROM TabSensor WHERE zkbh = '"+zkbh.get(i).toString()+"' and mark = '"+mark+"' order by name";
				List sensorname = session.createQuery(b).list();
				List listzk = new ArrayList();
				String alarmname = "";
				for (int i2 = 0; i2 < sensorname.size(); i2++) {
					value value = new value ();
					TabSensor TabSensor2 = (TabSensor) sensorname.get(i2);
					sql ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value3,ifbj,ifstart FROM tab_neibuchenjiang nbcj where nbcj.sensorname='"+TabSensor2.getName()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd HH24:mi:ss')) from tab_neibuchenjiang where sensorname='"+TabSensor2.getName()+"' and ifview=1 ) - interval '7 day') and ifview=1  order by jctime";
					String sqll = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+TabSensor2.getName()+"') and ifzhengchang=2 and sensorname='"+TabSensor2.getName()+"'"; 
					query = session.createSQLQuery(sql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List list1 = (List<Object>) query.list();
					List list2 = session.createQuery(sqll).list();
					String ifguzhang = "0";
					if(list2.size()>0){
						ifguzhang = "1";
					}
					List listValue = new ArrayList();
					int id =0;
					for (int i3 = 0; i3 < list1.size(); i3++) {
						value2 value2= new value2();
						Map map =(Map)list1.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
					 	String  ylvalue = map.get("value3").toString();
						String ifbj = map.get("ifbj").toString();
						String ifstart = map.get("ifstart").toString();
						if("1".equals(ifbj)){
							id = 1;
						}
						 
						if("1".equals(ifstart)){
							ylvalue = null;
						}
						
						value2.setJctime(jctime.getTime()+"");
						value2.setValue(ylvalue);
						listValue.add(value2);
					}
					if(id==1){
						if(alarmname.equals("")){
							alarmname=TabSensor2.getName();
						}else{
							alarmname=alarmname + "*" + TabSensor2.getName();
						}
					}
					value.setAlarmnames(alarmname);
					value.setData(listValue);
					value.setIfbj(id+"");
					value.setIfguzhang(ifguzhang);
					value.setName(TabSensor2.getName());
					value.setPoumian(zk);
					String alarm = TabSensor2.getAlarmvalue().toString();
					String[] alarms = null;
					if(alarm.contains("|")){
						alarms = alarm.split("\\|");
						value.setAlarm1(alarms[0]);
						value.setAlarm2(alarms[1]);
						if(alarms.length>2){
							value.setAlarm3(alarms[2]);
						}
					}else{
						value.setAlarm1(alarm);
					}
					
					listzk.add(value);
				}
				listAll.add(listzk);
			}
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return listAll;
	}
	
	
	
	private int portto ;
	private String ip;

	/**
	 * @author Administrator
	 * @param 
	 *            ,û,ԭ //
	 */
	public int logstopalarm(String sensorname, String username, String reason) {
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		int oi = 0;
		Calendar calendat = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String dateStr = sdf.format(calendat.getTime());
		Timestamp ts = Timestamp.valueOf(dateStr);
		try {
			TabAlarmlog work2 = new TabAlarmlog();
			work2.setSensorname(sensorname);
			work2.setUsername(username);
			work2.setReason(reason);
			work2.setJiechutime(ts);
			work2.setKind("ڲ");
			ht.save(work2);
			// ±״̬
			Query query;
			if(sensorname.contains("*")){
				String[] name = sensorname.split("\\*");
				for (int i = 0; i < name.length; i++) {
					query = (Query) session
					.createQuery( "update  TabNeibuchenjiang user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ name[i]+ "' and ifbj ='1' ");
					((org.hibernate.Query) query).executeUpdate();
				}
			}else{
			
				query = (Query) session
						.createQuery( "update  TabNeibuchenjiang user2 set user2.ifbj ='0' ,user2.jcbjtime = '"+ ts+ "' where sensorname = '"+ sensorname+ "' and ifbj ='1' ");
				((org.hibernate.Query) query).executeUpdate();
			}
			
			query = session.createQuery("FROM TabNeibuchenjiang WHERE ifbj ='1'");
			if(query.list()==null||query.list().size()<=0){
				query = (Query) session
				.createQuery( "delete  from TabAlarmtype where alarmtype = 'ڲ'");
				((org.hibernate.Query) query).executeUpdate();
			}
			tx.commit();
			try {
				daohanglanImpl dhl = new daohanglanImpl();
				ip = dhl.getProperties("ip");
				portto = Integer.parseInt(dhl.getProperties("portto"));
				Socket socket = new Socket(ip, portto);
				OutputStream outputStream = socket.getOutputStream();
				String strFileName = "alarm" + sensorname;
				DataOutputStream outStream = new DataOutputStream(outputStream);
				byte[] bs = strFileName.getBytes("UTF-8");
				outStream.write(bs, 0, bs.length);
				Thread.sleep(1000);
				outStream.flush();
				outStream.close();
				socket.close();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			oi = 1;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return oi;
	}
	
	@SuppressWarnings("unchecked")
	public List<Object> Search_XX_new(String sensorname, String firstTime,
			String lastTime) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List listAll = new ArrayList();
		try{
			Query query;
			if(!firstTime.equals("1")||(!lastTime.equals("1"))){
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value3,ifstart FROM tab_neibuchenjiang where sensorname='"+name[i]+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List list =  query.list();
						List listValue = new ArrayList();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map map =(Map)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value3").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value3,ifstart FROM tab_neibuchenjiang where sensorname='"+sensorname+"' and jctime between '"+firstTime+"' and '"+lastTime+"'  and ifview =1  order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List list =  query.list();
					List listValue = new ArrayList();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map map =(Map)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			else{
				if(sensorname.contains("*")){
					String[] name  = sensorname.split("\\*");
					for (int i = 0; i < name.length; i++) {
						String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value3,ifstart FROM tab_neibuchenjiang jrx where jrx.sensorname='"+name[i]+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_neibuchenjiang where sensorname='"+name[i]+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
						query = session.createSQLQuery(jrxSql).setResultTransformer(
								Transformers.ALIAS_TO_ENTITY_MAP);
						List list =  query.list();
						List listValue = new ArrayList();
						value value = new value ();
						for (int i3 = 0; i3 < list.size(); i3++) {
							value2 value2= new value2();
							Map map =(Map)list.get(i3);
							Date jctime =  sdf.parse((map.get("jctime").toString()));
							String  ylvalue = map.get("value3").toString();
							String  ifstart = map.get("ifstart").toString();
							value2.setJctime(jctime.getTime()+"");
							//value2.setValue(ylvalue);
							if("1".equals(ifstart)){
								value2.setValue(null);
							}else{
								value2.setValue(ylvalue);
							}
							listValue.add(value2);
						}
						value.setData(listValue);
						value.setName(name[i]);
						listAll.add(value);
					}
				}else{
					String jrxSql = "SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,value3,ifstart FROM tab_neibuchenjiang jrx where jrx.sensorname='"+sensorname+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_neibuchenjiang where sensorname='"+sensorname+"' and ifview=1 ) - interval '7 day') and ifview=1   order by jctime";
					query = session.createSQLQuery(jrxSql).setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
					List list =  query.list();
					List listValue = new ArrayList();
					value value = new value ();
					for (int i3 = 0; i3 < list.size(); i3++) {
						value2 value2= new value2();
						Map map =(Map)list.get(i3);
						Date jctime =  sdf.parse((map.get("jctime").toString()));
						String  ylvalue = map.get("value3").toString();
						String  ifstart = map.get("ifstart").toString();
						value2.setJctime(jctime.getTime()+"");
						//value2.setValue(ylvalue);
						if("1".equals(ifstart)){
							value2.setValue(null);
						}else{
							value2.setValue(ylvalue);
						}
						listValue.add(value2);
					}
					value.setData(listValue);
					value.setName(sensorname);
					listAll.add(value);
				}
			}
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
			return listAll;
	}
	
	/**
	 * mark
	 * @return ״̬
	 */
	@SuppressWarnings("unchecked")
	public List<Object> Search_CGQ_new(String mark) {
		Session session = HibernateUtil.openSession();
		Transaction tr = session.beginTransaction();
		List list  = new ArrayList();
		try {
			String a = "SELECT name FROM TabSensor  WHERE mark='"+mark+"' and state<>'FB' order by name";
			List sensor = session.createQuery(a).list();
			for (int i = 0; i < sensor.size(); i++) {
				value value = new value();
				String b = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+sensor.get(i).toString()+"') and ifzhengchang=2 and sensorname='"+sensor.get(i).toString()+"'";
				String c ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,ifbj FROM tab_neibuchenjiang spwy where spwy.sensorname='"+sensor.get(i).toString()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_neibuchenjiang where sensorname='"+sensor.get(i).toString()+"' and ifview='1') - interval '7 day') and ifview='1' and ifbj='1' order by jctime";
				String ifguzhang="0";
				String ifbj = "0";
				List guzhanglist = session.createQuery(b).list();
				List bjlist = session.createSQLQuery(c).list();
				if(guzhanglist.size()>0){
					ifguzhang="1";	
				}
				if(bjlist.size()>0){
					ifbj = "1";
				}
				value.setIfguzhang(ifguzhang);
				value.setIfbj(ifbj);
				value.setName(sensor.get(i).toString());
				list.add(value);
			}
			tr.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tr) {
				tr.rollback();
			}
		}finally{
			HibernateUtil.close(session);
		}
		return list;
	}
	
	public List<Object> Search_CGQ_newFB(String mark) {
		Session session = HibernateUtil.openSession();
		Transaction tr = session.beginTransaction();
		List list  = new ArrayList();
		try {
			String a = "SELECT name FROM TabSensor  WHERE mark='"+mark+"' and state='FB' order by name";
			List sensor = session.createQuery(a).list();
			for (int i = 0; i < sensor.size(); i++) {
				value value = new value();
				String b = "FROM TabSensorerror WHERE id=(SELECT max(id) FROM TabSensorerror WHERE sensorname='"+sensor.get(i).toString()+"') and ifzhengchang=2 and sensorname='"+sensor.get(i).toString()+"'";
				String c ="SELECT  to_char(jctime,'yyyy-MM-dd HH24:mi:ss')as jctime,ifbj FROM tab_neibuchenjiang spwy where spwy.sensorname='"+sensor.get(i).toString()+"' and jctime >=((select date(to_char(max(jctime),'yyyy-MM-dd ')) from tab_neibuchenjiang where sensorname='"+sensor.get(i).toString()+"' and ifview='1') - interval '7 day') and ifview='1' and ifbj='1' order by jctime";
				String ifguzhang="0";
				String ifbj = "0";
				List guzhanglist = session.createQuery(b).list();
				List bjlist = session.createSQLQuery(c).list();
				if(guzhanglist.size()>0){ 
					ifguzhang="1";	
				}
				if(bjlist.size()>0){
					ifbj = "1";
				}
				value.setIfguzhang(ifguzhang);
				value.setIfbj(ifbj);
				value.setName(sensor.get(i).toString());
				list.add(value);
			}
			tr.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (null != tr) {
				tr.rollback();
			}
		}finally{
			HibernateUtil.close(session);
		}
		return list;
	}
	 
}
