package com.gemho.dao;

import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFClientAnchor;
import org.apache.poi.hssf.usermodel.HSSFComment;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFPatriarch;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;

import com.gemho.bean.TabSensor;
import com.gemho.bean.TabShenliuliang;
import com.gemho.daoIf.HistoryDao;
import com.gemho.util.HibernateUtil;

public class HistoryImpl {
	public List<?> fenye(int onePageSize, int fromRecord, String bh,String mark,String state){
		List<?> al = null;
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if(mark.equals("TabJinrunxian")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_jinrunxian where sensorname in(select name FROM tab_sensor  where tab_sensor.state='0') and  ifview=1 and ifstart=0 order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='0')  and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
				
			}else if(mark.equals("TabBatidibiaochenjiang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_batidibiaochenjiang  where  ifview=1 and ifstart=0 order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatineibubianxing")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,fangweiangle,qingjiao,fangweibianhualiang,qingjiaobianhualiang,qingjiaobei,qingjiaodong,ifbj,ifstart FROM tab_batineibubianxing  where sensorname in(select name FROM tab_sensor  where tab_sensor.state!='FB') and ifview='1' and ifstart='0' order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state!='FB') and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabGantanweiyi")){
				if ("".equals(bh)||bh==null){
					query = session.createQuery("from  "+mark+"   where ifstart = '0' and ifview = '1'  order by jctime desc,gantanid ");
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' order by jctime desc,gantanid");
				}
			}
			else{
			if ("".equals(bh)||bh==null)
				query = session.createQuery("from  "+mark+" object2  where object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='"+state+"') and ifstart = '0' and ifview = '1'  order by jctime desc,sensorname ");
			else
				query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='"+state+"') and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
			}
			query.setFirstResult(onePageSize);
			query.setMaxResults(fromRecord);
			al=query.list();
			return al;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}

	}
	public List<?> fenyeFB(int onePageSize, int fromRecord, String bh,String mark){
		List<?> al = null;
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if(mark.equals("TabJinrunxian")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_jinrunxian where sensorname in(select name FROM tab_sensor  where tab_sensor.state='FB') and ifview=1 and ifstart=0 order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
				
			}else if(mark.equals("TabBatidibiaochenjiang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_batidibiaochenjiang  where  ifview=1 and ifstart=0 order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatineibubianxing")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,fangweiangle,qingjiao,fangweibianhualiang,qingjiaobianhualiang,qingjiaobei,qingjiaodong,ifbj,ifstart FROM tab_batineibubianxing  where sensorname in(select name FROM tab_sensor  where tab_sensor.state='FB') and ifview='1' and ifstart='0' order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabGantanweiyi")){
				if ("".equals(bh)||bh==null){
					query = session.createQuery("from  "+mark+"  where ifstart = '0' and ifview = '1'  order by jctime desc,gantanid ");
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' order by jctime desc,gantanid");
				}
			}
			else{
			if ("".equals(bh)||bh==null)
				query = session.createQuery("from  "+mark+"  object2 where object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1'  order by jctime desc,sensorname ");
			else
				query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and  ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
			}
			query.setFirstResult(onePageSize);
			query.setMaxResults(fromRecord);
			al=query.list();
			return al;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}

	}
	public List<?> fenye1(int onePageSize, int fromRecord, String bh,String mark,String state){
		List<?> al = null;
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if(mark.equals("TabJinrunxian")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_jinrunxian  where    sensorname in (select name FROM tab_sensor  where tab_sensor.state='0') and  ifview=1 and ifstart=0 and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery("from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='0')  and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
				
			}else if(mark.equals("TabBatidibiaochenjiang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_batidibiaochenjiang  where  ifview=1 and ifstart=0 and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatineibubianxing")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,fangweiangle,qingjiao,fangweibianhualiang,qingjiaobianhualiang,qingjiaobei,qingjiaodong,ifbj,ifstart FROM tab_batineibubianxing  where  sensorname in(select name FROM tab_sensor  where tab_sensor.state!='FB') and ifview='1' and ifstart='0' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state!='FB') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabJiangyuliang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value1,value2,value3,ifbj FROM tab_jiangyuliang  where  ifview='1' and ifstart='0' and (ifbj='1' or ifbj='2' ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or ifbj='2' ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatidibiaoweiyi")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,curx,cury,disx,disy,ifbj FROM tab_batidibiaoweiyi  where  ifview='1' and ifstart='0' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}
			else{
			if ("".equals(bh)||bh==null)
				query = session.createQuery("from  "+mark+"  object2 where object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='"+state+"') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname ");
			else
				query = session.createQuery(" from  "+mark+" object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='"+state+"') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			}
			query.setFirstResult(onePageSize);
			query.setMaxResults(fromRecord);
			al=query.list();
			return al;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}

	}
	public List<?> fenye1FB(int onePageSize, int fromRecord, String bh,String mark){
		List<?> al = null;
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if(mark.equals("TabJinrunxian")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_jinrunxian  where    sensorname in (select name FROM tab_sensor  where tab_sensor.state='FB') and ifview=1 and ifstart=0 and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+"  object2 where "+bh+" and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
				
			}else if(mark.equals("TabBatidibiaochenjiang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value2,value3,ifbj,ifstart FROM tab_batidibiaochenjiang  where  ifview=1 and ifstart=0 and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatineibubianxing")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,fangweiangle,qingjiao,fangweibianhualiang,qingjiaobianhualiang,qingjiaobei,qingjiaodong,ifbj,ifstart FROM tab_batineibubianxing  where  sensorname in(select name FROM tab_sensor  where tab_sensor.state='FB') and ifview='1' and ifstart='0' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+"and object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB')  and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabJiangyuliang")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,value1,value2,value3,ifbj FROM tab_jiangyuliang  where  ifview='1' and ifstart='0' and (ifbj='1' or ifbj='2' ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or ifbj='2' ) order by jctime desc,sensorname");
				}
			}else if(mark.equals("TabBatidibiaoweiyi")){
				if ("".equals(bh)||bh==null){
					query = session.createSQLQuery("SELECT  jctime,zkname,sensorname,jcbjtime,curx,cury,disx,disy,ifbj FROM tab_batidibiaoweiyi  where  ifview='1' and ifstart='0' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname").setResultTransformer(
							Transformers.ALIAS_TO_ENTITY_MAP);
				}else{
					query = session.createQuery(" from  "+mark+" object2 where "+bh+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
				}
			}
			else{
			if ("".equals(bh)||bh==null)
				query = session.createQuery("from  "+mark+" object2  where object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname ");
			else
				query = session.createQuery(" from  "+mark+" object2 where "+bh+" and  object2.sensorname in (select SENSOR.name FROM TabSensor SENSOR where SENSOR.state='FB') and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			}
			query.setFirstResult(onePageSize);
			query.setMaxResults(fromRecord);
			al=query.list();
			return al;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}

	}
	//ÿҳҳ
	public  int page(String sql,String mark){
		Session session = HibernateUtil.openSession();
		Query query;
		if("".equals(sql)||sql==null){
			query = session.createQuery("select count(n.id) from "+mark+" n where  ifstart = '0' and ifview = '1'");
		}else{
			query = session.createQuery("select count(n.id) from "+mark+" n where "+sql+"  and ifstart = '0' and ifview = '1'");
		}
		if(query.uniqueResult()==null){
			return 0;
		}
		return Integer.parseInt(query.uniqueResult()+"");
	}
	
	
	
	public  int page1(String sql,String mark){
		Session session = HibernateUtil.openSession();
		Query query;
		if("TabJiangyuliang".equals(mark)){
			if("".equals(sql)||sql==null){
				query = session.createQuery("select count(n.id) from "+mark+" n where  ifstart = '0' and ifview = '1' and (ifbj='1' or ifbj='2' )");
			}else{
				query = session.createQuery("select count(n.id) from "+mark+" n where "+sql+" and  ifstart = '0' and ifview = '1' and (ifbj='1' or ifbj='2' )");
			}	
		}
		else{
		if("".equals(sql)||sql==null){
			query = session.createQuery("select count(n.id) from "+mark+" n where  ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime )");
		}else{
			query = session.createQuery("select count(n.id) from "+mark+" n where "+sql+"  and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime )");
		}
		}
		if(query.uniqueResult()==null){
			return 0;
		}
		return Integer.parseInt(query.uniqueResult()+"");
	}
	

	@SuppressWarnings("unchecked")
	public List<TabSensor> getSensorname(String mark,String state){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<TabSensor> list = null;
		try {
			Query query;
			query = session.createQuery("from TabSensor SENSOR where mark='"+mark+"' and SENSOR.state='"+state+"' order by id");
			//session.createSQLQuery("select name from Tab_sensor where mark="+mark).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			list = query.list();
			return  list;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}
		
	}
	@SuppressWarnings("unchecked")
	public List<TabSensor> getSensornamex(String mark){
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<TabSensor> list = null;
		try {
			Query query;
			query = session.createQuery("from TabSensor SENSOR where mark='"+mark+"' and SENSOR.state='FB' order by id");
			//session.createSQLQuery("select name from Tab_sensor where mark="+mark).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			list = query.list();
			return  list;
		} catch (Exception ex) {
			ex.printStackTrace();
			if (null != tx) {
				tx.rollback();
			}
			return null;
		} finally {
			HibernateUtil.close(session);
		}
		
	}
	
	// execl
	static String[] title = { "", "ʱ", "ʱ",
		"Ƿ񱨾", "ۼ", "ʵʱ"};


	public String Search_excel(String where1,int start,int ps,OutputStream out) {
		String s_result = "test";
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<?> list = null;
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if ("".equals(where1))
				query = (Query) session
						.createQuery(" from  TabShenliuliang object2 where ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
			else {
				query = (Query) session
						.createQuery(" from  TabShenliuliang object2   where "+where1+" and ifstart = '0' and ifview = '1' order by jctime desc,sensorname");
			}
			query.setFirstResult(start);
			query.setMaxResults(ps);
			list = query.list();
			exportExcel("ʷ",title,list, out);
			out.close();
			tx.commit();
		} catch (Exception ex) {
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return s_result;
	}
	
	public String Search_excel1(String where1,int start,int ps,OutputStream out) {
		String s_result = "test";
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		List<?> list = null;
		try {
			// PersonֶǱ֣Ȼ־ҪϸִСд
			Query query;
			if ("".equals(where1))
				query = (Query) session
						.createQuery(" from  TabShenliuliang object2 where ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			else {
				query = (Query) session
						.createQuery(" from  TabShenliuliang object2  where "+where1+" and ifstart = '0' and ifview = '1' and (ifbj='1' or jctime<>jcbjtime ) order by jctime desc,sensorname");
			}
			query.setFirstResult(start);
			query.setMaxResults(ps);
			list = query.list();
			exportExcel("¼",title,list, out);
			out.close();
			tx.commit();
		} catch (Exception ex) {
			if (null != tx) {
				tx.rollback();
			}
		} finally {
			HibernateUtil.close(session);
		}
		return s_result;
	}

	 @SuppressWarnings("deprecation")
	public void exportExcel(String title, String[] headers,
	    		List<?> list, OutputStream out) {
	         SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	        // һ
	        HSSFWorkbook workbook = new HSSFWorkbook();
	        // һ
	        HSSFSheet sheet = workbook.createSheet(title);
	        // ñĬпΪ15ֽ
	        sheet.setDefaultColumnWidth((short) 25);
	        sheet.setDefaultRowHeight((short) 350);
	        // һʽ
	        HSSFCellStyle style = workbook.createCellStyle();
	        // Щʽ
	        style.setFillForegroundColor(HSSFColor.SKY_BLUE.index);
	        style.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
	        style.setBorderBottom(HSSFCellStyle.BORDER_THIN);
	        style.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        style.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        style.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
	        // һ
	        HSSFFont font = workbook.createFont();
	        font.setColor(HSSFColor.VIOLET.index);
	        font.setFontHeightInPoints((short) 12);
	        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
	        // Ӧõǰʽ
	        style.setFont(font);
	        // ɲһʽ
	        HSSFCellStyle style2 = workbook.createCellStyle();
	        style2.setFillForegroundColor(HSSFColor.LIGHT_YELLOW.index);
	        style2.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
	        style2.setBorderBottom(HSSFCellStyle.BORDER_THIN);
	        style2.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        style2.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        style2.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        style2.setAlignment(HSSFCellStyle.ALIGN_CENTER);
	        style2.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
	        // һ
	        HSSFFont font2 = workbook.createFont();
	        font2.setBoldweight(HSSFFont.BOLDWEIGHT_NORMAL);
	        // Ӧõǰʽ
	        style2.setFont(font2);

	        // һͼĶ
	        HSSFPatriarch patriarch = sheet.createDrawingPatriarch();
	        // ע͵ĴСλ,ĵ
	        HSSFComment comment = patriarch.createComment(new HSSFClientAnchor(0,
	                0, 0, 0, (short) 4, 2, (short) 6, 5));
	        // ע
	        comment.setString(new HSSFRichTextString("β"));
	        // עߣƶԪǿ״̬п.
	        comment.setAuthor("С");

	        // 
	        HSSFRow row = sheet.createRow(0);
	        for (short i = 0; i < headers.length; i++) {
	            HSSFCell cell = row.createCell(i);
	            cell.setCellStyle(style);
	            HSSFRichTextString text = new HSSFRichTextString(headers[i]);
	            cell.setCellValue(text);
	        }

	        // ݣ
	        Iterator<?> it = list.iterator();
	        int index = 0;
	        while (it.hasNext()) {
	            index++;
	            row = sheet.createRow(index);
	            TabShenliuliang t = (TabShenliuliang)it.next();
	            List<String> lt = new ArrayList<String>();
	            String sensorname = t.getSensorname();
	            lt.add(sensorname);
	            Date jctime = t.getJctime();
	            String jt = sdf.format(jctime);
	            lt.add(jt);
	            Date jcbjtime = t.getJcbjtime();
	            String jbt = sdf.format(jcbjtime);
	            lt.add(jbt);
	            String ifbj  = "";
	            String ib = t.getIfbj();
	            if("1".equals(ib)||!jt.equals(jbt)){
	            	ifbj = "";
	            }
	            lt.add(ifbj);
	            lt.add(t.getValue2().toString());
	            lt.add(t.getValue3().toString());
	        //    Field[] fields = t.getClass().getDeclaredFields();
	            for (short i = 0; i < lt.size(); i++) {
	                HSSFCell cell = row.createCell(i);
	                cell.setCellStyle(style2);
	                String field = lt.get(i);
	                cell.setCellValue(field);
	             
	            }

	        }
	        try {
	            workbook.write(out);
	        } catch (IOException e) {
	            // TODO Auto-generated catch block
	            e.printStackTrace();
	        }
	    }

	
	
}
